<?php
require_once("vcl/vcl.inc.php");
//Includes
use_unit("interbase.inc.php");
use_unit("dbtables.inc.php");
use_unit("forms.inc.php");
use_unit("extctrls.inc.php");
use_unit("stdctrls.inc.php");

//Benchmark Scale
define('SCALING_FACOTR', 10000);

//Class definition
class Unit1 extends Page
{
       public $Memo2 = null;
       public $Memo1 = null;
       public $IBQuery1 = null;
       public $IBDatabase1 = null;
       public $Button2 = null;
       public $Button1 = null;
       public $Query1 = null;
       public $Database1 = null;

       private $data = 'あいうえおかきくけこさしすせそたちつてとなにぬねのはひふへほまみむめもやゆよらりるれろわをん';

       function getInsertQuery()
       {
         $seedlen = mb_strlen($this->data, 'UTF-8');
         $len = rand(1,10);
         for($idx=0;$idx<$len;$idx++)
         {
           $chr = mb_substr($this->data, rand(0,$seedlen-1), 1, 'UTF-8');
           $str .= $chr;
         }
         return "INSERT INTO TBL(COL1, COL2, COL3, COL4)VALUES('$str','$str','$str','$str');";
       }

       function getUpdateQuery($maxrows)
       {
         $seedlen = mb_strlen($this->data, 'UTF-8');
         $len = rand(1,10);
         for($idx=0;$idx<$len;$idx++)
         {
           $chr = mb_substr($this->data, rand(0,$seedlen-1), 1, 'UTF-8');
           $str .= $chr;
         }
         $target = rand(1, $maxrows);
         return "UPDATE TBL SET COL1='$str', COL2='$str', COL3='$str', COL4='$str' WHERE ID=$target;";
       }

       function addMemoLines($memo, $text)
       {
         $lines = $memo->Text;
         $lines .= $text."\n";
         $memo->Text = $lines;
       }

       function doConnet($db, $memo)
       {
         $db->Open();
         $this->addMemoLines($memo, $db->ClassName()." opened.");
       }

       function doDisConnect($db, $memo)
       {
         $db->Close();
         $this->addMemoLines($memo, $db->ClassName()." closed.");
       }

       function doTest1($db, $memo, $numinserts=1000)
       {
         //init table and generator
         $db->BeginTrans();
         try
         {
           $db->execute('DELETE FROM TBL;');
           if (!$db->CompleteTrans()) throw new Exception(ibase_errmsg ());
         }catch(Exception $e){
           $this->addMemoLines($memo, $e->getMessage());
           $db->CompleteTrans(false);
         }
         $db->execute('SET GENERATOR GEN_TBL_ID TO 0;');

         srand(20090927); //乱数系列を揃えるため

         $t1 = microtime();
         $db->BeginTrans();
         try
         {
           for($idx=0;$idx<$numinserts;$idx++)
           {
             $db->execute($this->getInsertQuery());
           }
           if (!$db->CompleteTrans()) throw new Exception(ibase_errmsg ());
         }catch(Exception $e){
           $this->addMemoLines($memo, $e->getMessage());
           $db->CompleteTrans(false);
         }
         $t2 = microtime();

         list($m1, $u1) = explode(" ", $t1);
         $t1 = $u1+$m1;
         list($m2, $u2) = explode(" ", $t2);
         $t2= $u2+$m2;
         $tv = $t2 - $t1;
         list($uv, $mv) = explode(".", $tv);

         $this->addMemoLines($memo, $numinserts." Inserts requires ".date('i:s',$uv).".$mv");
       }

       function doTest2($db, $qry, $memo, $numupdates=1000)
       {
         //Check maxrows
         $db->BeginTrans();
         try
         {
           $qry->SQL = 'SELECT COUNT(*) AS CNT FROM TBL;';
           $qry->Open();
           $countrows = $qry->Fields['CNT']*1;
           $qry->Close();
           if (!$db->CompleteTrans()) throw new Exception(ibase_errmsg ());
         }catch(Exception $e){
           $this->addMemoLines($memo, $e->getMessage());
           $db->CompleteTrans(false);
         }
         $this->addMemoLines($memo, "Count TBL rows: $countrows.");

         srand(20090927+1); //乱数系列を揃えるため

         $t1 = microtime();
         $db->BeginTrans();
         try
         {
           for($idx=0;$idx<$numupdates;$idx++)
           {
             $db->execute($this->getUpdateQuery($countrows));
           }
           if (!$db->CompleteTrans()) throw new Exception(ibase_errmsg ());
         }catch(Exception $e){
           $this->addMemoLines($memo, $e->getMessage());
           $db->CompleteTrans(false);
         }
         $t2 = microtime();

         list($m1, $u1) = explode(" ", $t1);
         $t1 = $u1+$m1;
         list($m2, $u2) = explode(" ", $t2);
         $t2= $u2+$m2;
         $tv = $t2 - $t1;
         list($uv, $mv) = explode(".", $tv);

         $this->addMemoLines($memo, $numupdates." Updates requires ".date('i:s',$uv).".$mv");
       }

       function Button1Click($sender, $params)
       {
         $this->doConnet($this->Database1, $this->Memo1);
         $this->doTest1($this->Database1, $this->Memo1, SCALING_FACOTR);
         $this->doTest2($this->Database1, $this->Query1, $this->Memo1, SCALING_FACOTR);
         $this->doDisConnect($this->Database1, $this->Memo1);
      }

       function Button2Click($sender, $params)
       {
         $this->doConnet($this->IBDatabase1, $this->Memo2);
         $this->doTest1($this->IBDatabase1, $this->Memo2, SCALING_FACOTR);
         $this->doTest2($this->IBDatabase1, $this->IBQuery1, $this->Memo2, SCALING_FACOTR);
         $this->doDisConnect($this->IBDatabase1, $this->Memo2);
       }


}

global $application;

global $Unit1;

//Creates the form
$Unit1=new Unit1($application);

//Read from resource file
$Unit1->loadResource(__FILE__);

//Shows the form
$Unit1->show();

?>